将复合对象分解为子实体。 支持的平台:仅窗口 返回值(RetVal)类型:变体(对象数组) 分解对象的数组。 言论根据要爆炸的复合对象的类型,会出现不同的结果。有关可爆炸对象及其结果的详细列表,请参阅 AutoCAD 命令参考中的“分解”命令主题。 您不必为了操纵其组成实体而分解块。所有块定义都有一个方法,允许您在不爆炸块定义本身的情况下操作块内的实体。Item 注意:Theandobjects 继承此方法,但此方法在使用时不会影响任一对象类型。ComparedReferenceExternalReferenceBlockReference
例子工 务 局: Sub Example_Explode() ' This example creates a lightweight polyline in model space. ' It then explodes the polyline. Dim plineObj As AcadLWPolyline Dim points(0 To 11) As Double ' Define the 2D polyline points points(0) = 1: points(1) = 1 points(2) = 1: points(3) = 2 points(4) = 2: points(5) = 2 points(6) = 3: points(7) = 2 points(8) = 4: points(9) = 4 points(10) = 4: points(11) = 1 ' Create a lightweight Polyline object in model space Set plineObj = ThisDrawing.ModelSpace.AddLightWeightPolyline(points) ' Set the bulge on one segment to vary the ' type of objects in the polyline plineObj.SetBulge 3, -0.5 ZoomAll ' Explode the polyline MsgBox "Explode the polyline?", , "Explode Example" Dim explodedObjects As Variant explodedObjects = plineObj.Explode ' Loop through the exploded objects Dim I As Integer For I = 0 To UBound(explodedObjects) explodedObjects(I).Update MsgBox "Exploded Object " & I & ": " & explodedObjects(I).ObjectName, , "Explode Example" explodedObjects(I).Color = acByLayer explodedObjects(I).Update Next End Sub Visual LISP: (vl-load-com) (defun c:Example_Explode() ;; This example creates a lightweight polyline in model space. ;; It then explodes the polyline. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) ;; Define the 2D polyline points (setq points (vlax-make-safearray vlax-vbDouble '(0 . 11))) (vlax-safearray-fill points '(1 1 1 2 2 2 3 2 4 4 4 1 ) ) ;; Create a lightweight Polyline object in model space (setq modelSpace (vla-get-ModelSpace doc)) (setq plineObj (vla-AddLightWeightPolyline modelSpace points)) (vla-put-Color plineObj acRed) ;; Set the bulge on one segment to vary the ;; type of objects in the polyline (vla-SetBulge plineObj 3 -0.5) (vla-ZoomAll acadObj) ;; Explode the polyline (alert "Explode the polyline?") (setq explodedObjects (vlax-variant-value (vla-Explode plineObj))) ;; Loop through the exploded objects (setq I 0) (while (>= (vlax-safearray-get-u-bound explodedObjects 1) I) (vla-Update (vlax-safearray-get-element explodedObjects I)) (alert (strcat "Exploded Object " (itoa I) ": " (vla-get-ObjectName (vlax-safearray-get-element explodedObjects I)))) (vla-put-Color (vlax-safearray-get-element explodedObjects I) acByLayer) (vla-Update (vlax-safearray-get-element explodedObjects I)) (setq I (1+ I)) ) ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2025-1-8 19:14
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.